/*
 * hifi_usb.h
 *
 * Copyright (c) 2017-2020 Huawei Technologies Co., Ltd.
 *
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 */

#ifndef _LINUX_HIFI_USB_H_
#define _LINUX_HIFI_USB_H_
#include <linux/usb.h>

static inline int usb_start_hifi_usb(struct usb_device *udev)
{
	return -1;
}
static inline int usb_start_hifi_usb_reset_power(struct usb_device *udev)
{
	return -1;
}
static inline void usb_stop_hifi_usb_by_portid(int portid)
{
}
static inline void usb_stop_hifi_usb(struct usb_device *udev)
{
}
static inline void usb_stop_hifi_usb_reset_power(struct usb_device *udev)
{
}
static inline bool usb_using_hifi_usb(struct usb_device *udev)
{
	return false;
}
static inline int start_hifi_usb(void)
{
	return -1;
}
static inline void stop_hifi_usb(void)
{
}
static inline void reset_hifi_usb(void)
{
}
static inline int get_never_hifi_usb_value(void)
{
	return 0;
}
static inline int get_always_hifi_usb_value(void)
{
	return 0;
}
static inline int get_hifi_usb_retry_count(void)
{
	return 0;
}
static inline int get_usbaudio_nv_is_ready(void)
{
	return 1;
}
static inline void export_usbhid_key_pressed(struct usb_device *udev, bool key_pressed)
{
}
static inline void hifi_usb_hifi_reset_inform(void)
{
}
static inline int usb_find_portid_by_udev(struct usb_device *udev)
{
	return 0;
}
static inline bool is_hifi_usb_in_used(void)
{
	return false;
}


/* parameters passed to check_hifi_usb_status */
enum hifi_usb_status_trigger {
	HIFI_USB_AUDIO = 1,
	HIFI_USB_TCPC,
	HIFI_USB_FB,
	HIFI_USB_PROXY,
	HIFI_USB_URB_ENQUEUE,
};

#ifdef CONFIG_USB_PROXY_HCD_HIBERNATE
int hifi_usb_hibernate(void);

int hifi_usb_revive(void);

/* This function is used to make sure hifiusb alive. If hifiusb hibernated,
 * revive it. */
int check_hifi_usb_status(enum hifi_usb_status_trigger trigger);
void check_customized_earphone_device(struct usb_device *dev);
#else
static inline int hifi_usb_hibernate(void)
{
	return -1;
}
static inline int hifi_usb_revive(void)
{
	return -1;
}
static inline int check_hifi_usb_status(enum hifi_usb_status_trigger trigger)
{
	return -1;
}
static inline void check_customized_earphone_device(struct usb_device *dev)
{
}
#endif

#ifdef CONFIG_SND
extern int usbaudio_nv_is_ready(void);
#else
static inline int usbaudio_nv_is_ready(void)
{
	return 1;
}
#endif

#endif /* _LINUX_HIFI_USB_H_ */
