/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2021. All rights reserved.
 * Description: ufs vcmd header file
 *
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef __UFS_VCMD_PROC_H__
#define __UFS_VCMD_PROC_H__

#include "ufs.h"
#include "ufshcd.h"

#define VCMD_REQ_RETRIES 5


struct ufs_query_vcmd {
	enum query_opcode opcode;
	u8 idn;
	u8 index;
	u8 selector;
	u8 query_func;
	u8 lun;
	bool has_data;
	__be32 value;
	__be16 reserved_osf;
	__be32 reserved[2];

	u8 *desc_buf;
	int buf_len;
	struct ufs_query_res *response;
};


int ufshcd_query_vcmd_single(struct ufs_hba *hba,
	struct ufs_query_vcmd *cmd);
int ufshcd_query_vcmd_retry(struct ufs_hba *hba,
	struct ufs_query_vcmd *cmd);
#endif
