/*
 * lpcpu_cpufreq_dt.h
 *
 * lpcpu cpufreq device tree head file
 *
 * Copyright (c) 2012-2020 Huawei Technologies Co., Ltd.
 *
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 */

#ifndef _LPCPU_CPUFREQ_DT_H
#define _LPCPU_CPUFREQ_DT_H

#include <linux/cpufreq.h>
#include <linux/version.h>
#ifdef CONFIG_FREQ_STATS_COUNTING_IDLE
#include <linux/cpumask.h>
#include <linux/of_device.h>
#endif


#ifdef CONFIG_LPCPU_CPUFREQ_DT
struct opp_table *lpcpu_cpufreq_set_supported_hw(struct device *cpu_dev);
void lpcpu_cpufreq_put_supported_hw(struct opp_table *opp_table);
int lpcpu_get_cpu_version(unsigned int *cpu_version);

void lpcpu_cpufreq_get_suspend_freq(struct cpufreq_policy *policy);
int lpcpu_cpufreq_init(void);


#endif
#endif /* _LPCPU_CPUFREQ_DT_H */
