#!/bin/bash

###################### UPDATE KERNEL VERSION ##########################

LAST_VERSION=`git log  -n 1  --pretty="%H" Makefile`

# 更新 Makefile 的版本信息
V=`sed -n 's/^EXTRAVERSION = -//p' Makefile`
BV=`sed -n 's/^KYLIN_BUILD_VERSION = //p' Makefile`

let NOW=$((V))+1
let BV_NOW=$((BV))+1

sed -i "/EXTRAVERSION =/d" Makefile
sed -i "/SUBLEVEL =/aEXTRAVERSION = -${NOW}" Makefile
sed -i "/KYLIN_BUILD_VERSION =/d" Makefile
sed -i "/EXTRAVERSION =/aKYLIN_BUILD_VERSION = ${BV_NOW}" Makefile

VERSION=`sed -n 's/^VERSION = //p' Makefile`
PATCHLEVEL=`sed -n 's/^PATCHLEVEL = //p' Makefile`
SUBLEVEL=`sed -n 's/^SUBLEVEL = //p' Makefile`

TEMPFILE="/tmp/.changelog"

# 新增 Deb changelog 信息
echo "linux (${VERSION}.${PATCHLEVEL}.${SUBLEVEL}-${NOW}.${BV_NOW}) v101; urgency=low" > $TEMPFILE
echo "" >> $TEMPFILE
git log HEAD...${LAST_VERSION} --pretty=oneline --pretty="format:  * [%h]" >> $TEMPFILE
echo "" >> $TEMPFILE
echo "" >> $TEMPFILE
echo " -- huanglei <huanglei@kylinos.cn>  `date -R`" >> $TEMPFILE
echo "" >> $TEMPFILE
cat debian.master/changelog >> $TEMPFILE
\mv $TEMPFILE debian.master/changelog

git commit CHANGELOG.md Makefile debian.master/changelog -s -m  "Update kernel version to ${VERSION}.${PATCHLEVEL}.${SUBLEVEL}-${NOW}.${BV_NOW}

更新内核至 ${VERSION}.${PATCHLEVEL}.${SUBLEVEL}-${NOW}.${BV_NOW}"
